#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cctype>
#include <cstring>
#include <string>
#include <limits>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>


using namespace std;

int c, r;


char buffer[40];

map<string, int> kody;

int euklid(int a,int b){
  if (b == 0) return a;
  else return euklid(b, a % b);
  
}

struct Zlomek{
  int cit;
  int jmen;
  
  bool operator<(const Zlomek& z)const{
    return cit * z.jmen <  z.cit*jmen;
  }
  
  bool operator>(const Zlomek& z)const{
    return cit * z.jmen >  z.cit*jmen;
  }
  
  Zlomek operator *(const Zlomek& z)const{
    int d = euklid(cit*z.cit,jmen*z.jmen);
    return Zlomek (cit*z.cit/d,jmen*z.jmen/d);
  }
  
  Zlomek(int c,int j):cit(c),jmen(j){}
  Zlomek(){}
};

double graf[400];

struct Hrana{
  int z, d;
  double pomer;
};



Hrana hrany[40400];

int main()
{
  while(1)
  {
    scanf("%d", &c);
    if (!c)
      break;
    
    for (int i=0; i<=c; i++)
        graf[i] = -100000000;
    
    kody.clear();
    
    
    for (int i=0; i<c; i++){
      scanf(" %s", buffer);
      kody.insert(pair<string,int>(string(buffer), i));
    }
    scanf("%d", &r);
    char k1[4], k2[4];
    int i1, i2, p1, p2;
    for (int i=0; i<r; i++)
    {
      scanf(" %s %s %d:%d", k1, k2, &p1, &p2);
      i1 = kody[k1];
      i2 = kody[k2];
      
      hrany[i].z = i1;
      hrany[i].d = i2;
      hrany[i].pomer = log((double)p2/(double)p1);
      
    }
    
    for(int i=0;i<c;++i){
      hrany[r+i].z = c;
      hrany[r+i].d = i;
      hrany[r+i].pomer = 0;
    }
    bool arbitrage = false;
    
    graf[c] = 0;
    
    // belman ford
    for(int i=0;i<c+2;++i){
      bool changed = false;
      for(int j=0;j<r+c;++j){
        int z = hrany[j].z;
        int d = hrany[j].d;
        if(graf[z]+hrany[j].pomer>graf[d]+0.00001){
          graf[d] = graf[z]+hrany[j].pomer;
          //printf("%d to %d w %d/%d\n",z,d,graf[d].cit,graf[d].jmen );
          changed = true;
       
        }
      }
      if(i == c+1 && changed){
        arbitrage = true;
      }
    }
    printf(arbitrage?"Arbitrage\n":"Ok\n");
    
  }
  return 0;
}

