#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cctype>
#include <cstring>
#include <string>
#include <limits>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>

using namespace std;

int p1[200200];
int p2[200200];
int p3[200200];

int o1[200200];
int o2[200200];
int o3[200200];

int interval[1000100];

int tree_get(int node, int begin, int end, int N){
  
  int middle = (begin + end) / 2;
  
 
  if(N<=begin)
    return 0;
  if(begin + 1 == end)
    return interval[node];
  
  if(N<=middle){
    return tree_get(node*2, begin, middle, N);
  } 
  else{
    return interval[node*2] + tree_get(node*2 + 1, middle,end, N);
  }
  
}

void tree_add(int node, int begin, int end, int i){
  int middle = (begin + end) / 2;
  
  if(i<=begin)
    return;
 
  interval[node]++;
  
  if(begin + 1 == end)
    return;
  
  if(i<=middle){
    tree_add(node*2, begin, middle, i);
  }
  else{
    tree_add(node*2+1, middle, end, i);
  }

}


int main()
{
  int N;
  while(1){
    
    scanf("%d",&N);
    if(!N)
      break;
   
    for(int i=0;i<N;++i){
      scanf("%d",&p1[i]);
      p1[i]--;
      o1[p1[i]]=i;
    }
    for(int i=0;i<N;++i){
      scanf("%d",&p2[i]);
      p2[i]--;
      o2[p2[i]]=i;
    }
    for(int i=0;i<N;++i){
      scanf("%d",&p3[i]);
      p3[i]--;
      o3[p3[i]]=i;
    }
    
    long long dif = 0;
    for(int i=0;i<N;++i){
      int pos = o2[p1[i]];
      tree_add(1,0,N,pos+1);
      dif += pos-tree_get(1,0,N,pos);
    }

    for(int i=0;i<4*N;++i)
      interval[i] = 0;
    
    for(int i=0;i<N;++i){
      int pos = o3[p1[i]];
      tree_add(1,0,N,pos+1);
      dif += pos-tree_get(1,0,N,pos);
    }
     
    for(int i=0;i<4*N;++i)
      interval[i] = 0;
    for(int i=0;i<N;++i){
      int pos = o3[p2[i]];
      tree_add(1,0,N,pos+1);
      dif += pos-tree_get(1,0,N,pos);
    }
     
    for(int i=0;i<4*N;++i)
      interval[i] = 0;
    
    long long int all = (long long)N *( (long long)N-1) / 2;
    
    printf("%lld\n",all - dif/2);
    
  }  
  return 0;
}
